Loading...
Searching...
No Matches
openshot::Tracker Class Reference

This class tracks a given object through the clip, draws a box around it and allow the user to attach another clip (image or video) to the tracked object. More...

`#include <effects/Tracker.h>`

Inheritance diagram for openshot::Tracker:

## Public Member Functions

std::shared_ptr< openshot::Frame > | GetFrame (int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.
std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number) override
| Apply this effect to an openshot::Frame.
std::string | GetVisibleObjects (int64_t frame_number) const override
| Get the indexes and IDs of all visible objects in the given frame.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
| Tracker ()
| Default constructor.
| Tracker (std::string clipTrackerDataPath)
| Blank constructor, useful when using Json to load the effect properties.
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects)
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout)
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL)
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds)
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video)
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video)
virtual std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number)=0
| This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers)
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers)
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any)
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds)
void | Position (float value)

> ‍Set the Id of this clip object

float | Start () const
| Get start position (in seconds) of clip (trim start of video)
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video)
virtual | ~ClipBase ()=default

## Public Attributes

std::string | protobuf_data_path
| Path to the protobuf file that holds the bounding-box data.
std::shared_ptr< TrackedObjectBBox > | trackedData
| Pointer to an object that holds the bounding-box data and it's Keyframes.
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties)
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips)

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties)
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any)
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip)
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip)
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any)

## Detailed Description

This class tracks a given object through the clip, draws a box around it and allow the user to attach another clip (image or video) to the tracked object.

Tracking is useful to better visualize, follow the movement of an object through video and attach an image or video to it.

Definition at line 41 of file Tracker.h.

## Constructor & Destructor Documentation

## Tracker() [1/2]

Tracker::Tracker | ( |  | ) |

Default constructor.

Definition at line 53 of file Tracker.cpp.

## Tracker() [2/2]

Tracker::Tracker | ( | std::string | clipTrackerDataPath | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 36 of file Tracker.cpp.

## Member Function Documentation

## GetFrame() [1/2]

std::shared_ptr< openshot::Frame > openshot::Tracker::GetFrame | ( | int64_t | frame_number | ) |

inline override virtual

This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.

Returns
  A new openshot::Frame object

Parameters

  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 67 of file Tracker.h.

## GetFrame() [2/2]

std::shared_ptr< Frame > Tracker::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

override

Apply this effect to an openshot::Frame.

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Definition at line 87 of file Tracker.cpp.

Referenced by GetFrame().

## GetVisibleObjects()

std::string Tracker::GetVisibleObjects | ( | int64_t | frame_number | ) | const

override virtual

Get the indexes and IDs of all visible objects in the given frame.

Reimplemented from openshot::EffectBase.

Definition at line 139 of file Tracker.cpp.

## Json()

std::string Tracker::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Reimplemented from openshot::EffectBase.

Definition at line 161 of file Tracker.cpp.

## JsonValue()

Json::Value Tracker::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 168 of file Tracker.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Tracker::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame

(perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 265 of file Tracker.cpp.

## SetJson()

void Tracker::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 194 of file Tracker.cpp.

## SetJsonValue()

void Tracker::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 212 of file Tracker.cpp.

Referenced by SetJson().

## Member Data Documentation

## protobuf_data_path

std::string openshot::Tracker::protobuf_data_path

Path to the protobuf file that holds the bounding-box data.

Definition at line 51 of file Tracker.h.

Referenced by JsonValue(), and SetJsonValue().

## trackedData

std::shared_ptr<TrackedObjectBBox> openshot::Tracker::trackedData

Pointer to an object that holds the bounding-box data and it's Keyframes.

Definition at line 52 of file Tracker.h.

Referenced by GetFrame(), SetJsonValue(), Tracker(), and Tracker().

The documentation for this class was generated from the following files:

- effects/Tracker.h
- effects/Tracker.cpp